## parallel-hashmap 1.3.11+ds

=== debian/changelog ===
parallel-hashmap (1.3.11+ds-1) unstable; urgency=medium

  * New upstream version 1.3.11+ds

 -- Andrius Merkys <merkys@debian.org>  Wed, 26 Apr 2023 04:24:26 -0400

parallel-hashmap (1.3.8+ds-3) unstable; urgency=medium

  * Accept only semantic versioned version numbers in debian/watch.

 -- Andrius Merkys <merkys@debian.org>  Wed, 08 Mar 2023 02:10:23 -0500

parallel-hashmap (1.3.8+ds-2) unstable; urgency=medium

  * Mention that parts of parallel_hashmap/phmap_utils.h is licensed under
    BSL-1.0.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Feb 2023 07:41:34 -0500

parallel-hashmap (1.3.8+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1021041)

 -- Andrius Merkys <merkys@debian.org>  Wed, 22 Feb 2023 02:32:26 -0500
