=== debian/rules ===
#!/usr/bin/make -f

PHMAP_BUILD_TESTS = OFF
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	PHMAP_BUILD_TESTS = ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPHMAP_BUILD_TESTS=$(PHMAP_BUILD_TESTS) -DPHMAP_GTEST_LIBS='gmock_main -lgmock -lgtest' -DPHMAP_MASTER_PROJECT=ON

execute_after_dh_auto_install:
	rm debian/libparallel-hashmap-dev/usr/include/parallel_hashmap/conanfile.py

override_dh_fixperms:
	find debian -name "*.cc" | xargs -r chmod -x
	dh_fixperms
