=== debian/changelog ===
parallel-hashmap (1.3.12+ds-1) unstable; urgency=medium

  * New upstream version 1.3.12+ds
  * Refresh debian/copyright.
  * Refresh include_directories.patch.

 -- Andrius Merkys <merkys@debian.org>  Wed, 31 Jan 2024 02:02:06 -0500
