=== debian/changelog ===
parallel-hashmap (1.4.1+ds-2) unstable; urgency=medium

  * Do not build examples on i386 (Closes: #1103144)

 -- Andrius Merkys <merkys@debian.org>  Mon, 14 Apr 2025 09:05:37 -0400

parallel-hashmap (1.4.1+ds-1) unstable; urgency=medium

  * New upstream version 1.4.1+ds
  * Drop include_directories.patch: no longer needed.
  * Add missing Perl shebang to an example via patch.

 -- Andrius Merkys <merkys@debian.org>  Fri, 22 Nov 2024 02:24:49 -0500
