## parallel-hashmap 1.4.1+ds

=== debian/changelog ===
parallel-hashmap (1.4.1+ds-3) unstable; urgency=medium

  * Build examples only on amd64 (Closes: #1113389)

 -- Andrius Merkys <merkys@debian.org>  Fri, 03 Oct 2025 02:41:06 -0400

parallel-hashmap (1.4.1+ds-3~exp1) experimental; urgency=medium

  * Move to arch:any.

 -- Andrius Merkys <merkys@debian.org>  Thu, 02 Oct 2025 10:56:54 -0400
