=== debian/control ===
--- 
+++ 
@@ -9,7 +9,9 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+ libboost-dev,
  libgmock-dev <!nocheck>,
+ libtbb-dev,
 Standards-Version: 4.6.2
 Homepage: https://github.com/greg7mdp/parallel-hashmap
 Vcs-Browser: https://salsa.debian.org/science-team/parallel-hashmap
