=== debian/rules ===
#!/usr/bin/make -f

PHMAP_BUILD_TESTS = OFF
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	PHMAP_BUILD_TESTS = ON
endif

# Build examples only on amd64 (see #1103144 and #1113389)
PHMAP_BUILD_EXAMPLES = OFF
ifeq "$(DEB_HOST_ARCH)" "amd64"
       PHMAP_BUILD_EXAMPLES = ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPHMAP_BUILD_TESTS=$(PHMAP_BUILD_TESTS) -DPHMAP_GTEST_LIBS='gmock_main -lgmock -lgtest' -DPHMAP_MASTER_PROJECT=ON -DPHMAP_BUILD_EXAMPLES=$(PHMAP_BUILD_EXAMPLES)

execute_before_dh_fixperms:
	find debian -name "*.cc" | xargs -r chmod -x
