=== debian/watch ===
version=4
opts="repack,repacksuffix=+ds,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%parallel-hashmap-$1.tar.gz%" \
 https://github.com/greg7mdp/parallel-hashmap/tags (?:.*?/)?v?(\d+\.\d+\.\d+)\.tar\.gz
